# Couenne::exprMax Class Reference

class for maxima More...

`#include <CouenneExprMax.hpp>`

Inheritance diagram for Couenne::exprMax:

List of all members.

## Public Member Functions
| exprMax (expression **al, int n)
| Constructor.
| exprMax (expression *el0, expression *el1)
| Constructor with only two arguments.
exprMax * | clone (Domain *d=NULL) const
| cloning method
std::string | printOp () const
| print operator
enum pos | printPos () const
| print position
CouNumber | operator() ()
| function for the evaluation of the expression
expression * | differentiate (int)
| differentiation
expression * | simplify ()
| simplification
virtual int | Linearity ()
| get a measure of "how linear" the expression is (see CouenneTypes.h)
void | getBounds (expression *&, expression *&)
virtual exprAux * | standardize (CouenneProblem *, bool addAux=true)
| reduce expression in standard form, creating additional aux variables (and constraints)
void | generateCuts (expression *w, OsiCuts &cs, const CouenneCutGenerator *cg, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| generate equality between *this and *w
virtual enum expr_type | code ()
| code for comparisons

## Detailed Description

class for maxima

Definition at line 22 of file CouenneExprMax.hpp.

## Constructor & Destructor Documentation

Couenne::exprMax::exprMax | ( | expression ** | al,
|  | int | n |
| ) |  |  | `[inline]`

Constructor.

Definition at line 27 of file CouenneExprMax.hpp.

Referenced by clone().

Couenne::exprMax::exprMax | ( | expression * | el0,
|  | expression * | el1 |
| ) |  |  | `[inline]`

Constructor with only two arguments.

Definition at line 31 of file CouenneExprMax.hpp.

References Couenne::exprOp::arglist_.

## Member Function Documentation

exprMax* Couenne::exprMax::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

cloning method

Reimplemented from Couenne::expression.

Definition at line 38 of file CouenneExprMax.hpp.

References Couenne::exprOp::clonearglist(), exprMax(), and Couenne::exprOp::nargs_.

std::string Couenne::exprMax::printOp | ( |  | ) | const`[inline, virtual]`

print operator

Reimplemented from Couenne::exprOp.

Definition at line 42 of file CouenneExprMax.hpp.

enum pos Couenne::exprMax::printPos | ( |  | ) | const`[inline, virtual]`

print position

Reimplemented from Couenne::exprOp.

Definition at line 46 of file CouenneExprMax.hpp.

References Couenne::PRE.

CouNumber Couenne::exprMax::operator() | ( |  | ) | `[inline, virtual]`

function for the evaluation of the expression

compute maximum

Implements Couenne::expression.

Definition at line 87 of file CouenneExprMax.hpp.

References Couenne::exprOp::arglist_, and Couenne::exprOp::nargs_.

expression* Couenne::exprMax::differentiate | ( | int |  | ) | `[inline, virtual]`

differentiation

Reimplemented from Couenne::expression.

Definition at line 53 of file CouenneExprMax.hpp.

expression* Couenne::exprMax::simplify | ( |  | ) | `[inline, virtual]`

simplification

Reimplemented from Couenne::exprOp.

Definition at line 57 of file CouenneExprMax.hpp.

virtual int Couenne::exprMax::Linearity | ( |  | ) | `[inline, virtual]`

get a measure of "how linear" the expression is (see CouenneTypes.h)

Reimplemented from Couenne::exprOp.

Definition at line 61 of file CouenneExprMax.hpp.

References Couenne::NONLINEAR.

void Couenne::exprMax::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  |

virtual exprAux* Couenne::exprMax::standardize | ( | CouenneProblem * | ,
|  | bool | addAux = `true` |
| ) |  |  | `[inline, virtual]`

reduce expression in standard form, creating additional aux variables (and constraints)

Reimplemented from Couenne::exprOp.

Definition at line 69 of file CouenneExprMax.hpp.

void Couenne::exprMax::generateCuts | ( | expression * | w,
|  | OsiCuts & | cs,
|  | const CouenneCutGenerator * | cg,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  |

generate equality between *this and *w

virtual enum expr_type Couenne::exprMax::code | ( |  | ) | `[inline, virtual]`

code for comparisons

Reimplemented from Couenne::exprOp.

Definition at line 80 of file CouenneExprMax.hpp.

References Couenne::COU_EXPRMAX.

The documentation for this class was generated from the following file:

- CouenneExprMax.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines